package com.rjconsultores.ventaboletos.dao.hibernate;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ConfComprovantePassagemDAO;
import com.rjconsultores.ventaboletos.entidad.ConfComprovantePassagem;

@Repository("comfComprovantePassagemDAO")
public class ConfComprovantePassagemHibernateDAO extends GenericHibernateDAO<ConfComprovantePassagem, Long> implements ConfComprovantePassagemDAO {

	@Autowired
	public ConfComprovantePassagemHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}
	
	@Override
	public ConfComprovantePassagem buscarPorEmpresaId(Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return (ConfComprovantePassagem) c.uniqueResult();
	}
	
	@Override
	public ConfComprovantePassagem buscarConfiguracao(Integer empresaId, String tipoIntegracao, String viaComprovante) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));
		c.add(Restrictions.eq("tipoIntegracao", tipoIntegracao));
		c.add(Restrictions.eq("viaComprovante", viaComprovante));

		return (ConfComprovantePassagem) c.uniqueResult();
	}
}
